// Ant.cpp: implementation of the Ant class.
//
//////////////////////////////////////////////////////////////////////



#include "stdafx.h"
#include "Assignment2.h"
#include "Ant.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
Ant::Ant(int X, int Y, Environment* e, Orientation Oriented, double PheromeneDecayRate):
EnvObject(X, Y), Env(e), myOrientation(Oriented),
food((FoodParticule*)0), m_PheromeneDecayRate(PheromeneDecayRate){
    
                

}

void Ant::moveTo(int NewX, int NewY){

    EnvObject::moveTo(NewX, NewY);
    if(isCarryingFood()){  
        //dropPheromone();
        if(!Env->moveObject(food, NewX, NewY))
            food = (FoodParticule*)0;
    }
}

void Ant::getRight(int* Coord){

    if(orientedNorth()) {Coord[0] = getX(); Coord[1] = getY()+1; return;}
    if(orientedSouth()) {Coord[0] = getX(); Coord[1] = getY()-1; return;}
    if(orientedWest())  {Coord[0] = getX()-1; Coord[1] = getY(); return;}
    if(orientedEast())  {Coord[0] = getX()+1; Coord[1] = getY(); return;}
}

void Ant::getLeft(int* Coord){

    if(orientedNorth()) {Coord[0] = getX(); Coord[1] = getY()-1; return;}
    if(orientedSouth()) {Coord[0] = getX(); Coord[1] = getY()+1; return;}
    if(orientedWest())  {Coord[0] = getX()+1; Coord[1] = getY(); return;}
    if(orientedEast())  {Coord[0] = getX()-1; Coord[1] = getY(); return;}
}

void Ant::getFront(int* Coord){

    if(orientedNorth()) {Coord[0] = getX()-1; Coord[1] = getY(); return;}
    if(orientedSouth()) {Coord[0] = getX()+1; Coord[1] = getY(); return;}
    if(orientedWest())  {Coord[0] = getX(); Coord[1] = getY()-1; return;}
    if(orientedEast())  {Coord[0] = getX(); Coord[1] = getY()+1; return;}
}


void Ant::moveRight(){
    int Coord[2];
    getRight(Coord);
    Env->moveObject(this, Coord[0], Coord[1]); 
    if(orientedNorth()) {myOrientation = EAST; return;}
    if(orientedSouth()) {myOrientation = WEST; return;}
    if(orientedWest())  {myOrientation = NORTH; return;}
    if(orientedEast())  {myOrientation = SOUTH; return;}
};

void Ant::moveLeft(){
    int Coord[2];
    getLeft(Coord);
    Env->moveObject(this, Coord[0], Coord[1]); 

    if(orientedNorth()) {myOrientation = WEST; return;}
    if(orientedSouth()) {myOrientation = EAST; return;}
    if(orientedWest())  {myOrientation = SOUTH; return;}
    if(orientedEast())  {myOrientation = NORTH; return;}
};          
void Ant::moveFront(){
    int Coord[2];
    getFront(Coord);
    Env->moveObject(this, Coord[0], Coord[1]); 
};    

bool Ant::isHome(){
    return Env->DirectionOfAntHill(getX(), getY()) == HERE;
}


void Ant::moveHome(){
            switch (Env->DirectionOfAntHill(getX(), getY()))
            {
                case EAST:
                    if(orientedEast()) moveFront();
                    else if(orientedNorth()) moveRight();
                    else moveLeft();
                    break;
                
                case WEST:
                    if(orientedWest()) moveFront();
                    else if(orientedSouth()) moveRight();
                    else moveLeft();
                    break;

                case NORTH:
                    if(orientedNorth()) moveFront();
                    else if(orientedWest()) moveRight();
                    else moveLeft();
                    break;

                case SOUTH:
                    if(orientedSouth()) moveFront();
                    else if(orientedEast()) moveRight();
                    else moveLeft();
                    break;
            }
}


void Ant::moveAdjacentPheromone(){

			int Coord[2];
    	
            getLeft(Coord);
			double d1 =  Env->foodPheromoneStrengthHere(Coord[0], Coord[1]);

			getRight(Coord);
            double d2 = Env->foodPheromoneStrengthHere(Coord[0], Coord[1]);

            getFront(Coord);
            double d3 = Env->foodPheromoneStrengthHere(Coord[0], Coord[1]);

			if(d1 < d2) 
				if(d1 < d3) moveLeft(); else moveFront();
			else
				if(d2 < d3) moveRight(); else moveFront();	
}

void Ant::moveAdjacentFood(){

			int Coord[2];
    	
            getLeft(Coord);
			if (Env->foodHere(Coord[0], Coord[1])) moveLeft();

			getRight(Coord);
            if (Env->foodHere(Coord[0], Coord[1])) moveRight();

            getFront(Coord);
            if (Env->foodHere(Coord[0], Coord[1])) moveFront();
}

void Ant::dropPheromone(){
  Pheromone* P;
    P = new Pheromone(getX(), getY(), FOODPHEROMONETYPE, m_PheromeneDecayRate);
    Env->addEnvObject(P);
}

bool Ant::is_adjacent_pheromone(){

            int Coord[2];
            getLeft(Coord);
            if(Env->foodPheromoneStrengthHere(Coord[0], Coord[1])) return true;
            getRight(Coord);
            if(Env->foodPheromoneStrengthHere(Coord[0], Coord[1])) return true;
            getFront(Coord);
            if(Env->foodPheromoneStrengthHere(Coord[0], Coord[1])) return true;
            
            return false;
}

bool Ant::is_adjacent_Food(){

            int Coord[2];
            getLeft(Coord);
            if(Env->foodHere(Coord[0], Coord[1])) return true;
            getRight(Coord);
            if(Env->foodHere(Coord[0], Coord[1])) return true;
            getFront(Coord);
            if(Env->foodHere(Coord[0], Coord[1])) return true;
        
            return false;
}



FoodParticule* Ant::senseFood(){
    return Env->foodHere(getX(), getY());
}


void Ant::draw(GLfloat hor_step, GLfloat vert_step){


	GLfloat Orient;
	switch(myOrientation){

		case NORTH:
			Orient = 0.0f;
			break;
		case SOUTH:
			Orient = 180.0f;
			break;
		case EAST:
			Orient = -90.0f;
			break;
		case WEST:
			Orient = 90.0f;
			break;
	}
	
	
	
	::glPushMatrix();
	::glRotatef(Orient, 0.0, 0.0, 1.0);
	::glBegin(GL_TRIANGLES);      
		
		glColor3f(1.0f, 0.5f, 0.0f);
		::glVertex3f(0.0, vert_step/2.0f, 0.0);
		::glVertex3f(hor_step/2.0f, vert_step, 0.0);
		glColor3f(0.0f, 0.0f, 0.0f);
		::glVertex3f(hor_step, vert_step/2.0f, 0.0);
		if(isCarryingFood())
		    glColor3f(1.0f, 0.5f, 0.7f);
		else
		glColor3f(0.0f, 0.7f, 0.15f);
		::glVertex3f(0.0, 0.0, 0.0);
		::glVertex3f(hor_step/2.0f, vert_step/2.0f, 0.0);
		glColor3f(0.0f, 0.0f, 0.0f);
		::glVertex3f(hor_step, 0.0, 0.0);
	::glEnd();
	::glPopMatrix();
}

bool Ant::play(GENEStatementType S){




    switch(S){
         
         case IS_ADJACENT_PHEROMONE:
                            return is_adjacent_pheromone();
         case IS_ADJACENT_FOOD:
                            return is_adjacent_Food();
         case IS_CARRYING_FOOD:
                            return isCarryingFood();                
         case FOOD_HERE:
                            return (!(!senseFood()));
         case IS_HOME:
                            return isHome();
         
         case MOVE_TO_ADJACENT_PHEROMONE:
							moveAdjacentPheromone();
							break;
         
         case MOVE_TO_ADJACENT_FOOD:
							moveAdjacentFood();
							break;
         
         case MOVE_RANDOM:
                            moveRandom();
                            break;        
         case MOVE_TO_NEST:                                
                            moveHome();
                            break;
         case PICK_UP_FOOD:
                            if(senseFood())
                                pickUpFood(senseFood());
                            break;
         case DROP_PHEROMONE:
                            dropPheromone();
                            break;
        
	case DROP_FOOD:
                            dropFood();
                            
    }  
      
    return true;
}           

Ant::~Ant(){
    
}
