// Ant.h: interface for the Ant class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ANT_H__9D6D8C57_8DEF_45C8_B40F_269095AA595C__INCLUDED_)
#define AFX_ANT_H__9D6D8C57_8DEF_45C8_B40F_269095AA595C__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "StdAfx.h"

#define MAXOBJPERMAPSQUARE 10
#define PHEROMONETOL 0.001

class Environment;
class Ant : public EnvObject{

    Environment * Env;
    FoodParticule* food;
    Orientation myOrientation;    
    double m_PheromeneDecayRate;
    public:
        Ant(int X, int Y, 
            Environment* e, 
	    Orientation Oriented = NORTH, 
	    double PheromeneDecayRate=0.5);

	
	virtual ~Ant();
        
        bool play(GENEStatementType S);   
        void moveTo(int NewX, int NewY);

        virtual void setOrientation(Orientation newOrientation){myOrientation = newOrientation;};
        virtual bool orientedEast(){return  myOrientation == EAST;};
        virtual bool orientedWest(){return  myOrientation == WEST;};
        virtual bool orientedNorth(){return myOrientation == NORTH;};
        virtual bool orientedSouth(){return myOrientation == SOUTH;};
        
        void getRight(int* Coord);
        void getLeft(int* Coord);
        void getFront(int* Coord);
                
        virtual void moveRight();                            
        virtual void moveLeft();
        virtual void moveFront();    
        
        
        void moveRandom(){
            int TurnSpike = rand()%3;
            if(TurnSpike == 0) {moveRight(); return;}
            if(TurnSpike == 1) {moveLeft(); return;}
            if(TurnSpike == 2) {moveFront(); return;}
        }
        
        void moveHome();
		void moveAdjacentPheromone();
		void moveAdjacentFood();

        bool isHome();
		bool isCarryingFood(){return (!(!food));};
        bool is_adjacent_pheromone();
        bool is_adjacent_Food();
        
        void dropPheromone();

		FoodParticule* senseFood();

        bool pickUpFood(FoodParticule* F){
            if((F)&&(!isCarryingFood()))
                if(!F->isBeingCarried){
                    food = F;
                    F->isBeingCarried = true;
                return true;
            }
            return false;
        };

		void Ant::dropFood(){
			if(food){
				food->isBeingCarried = false;
				food = ((FoodParticule*)0);
			}
		};



        void draw(GLfloat hor_step, GLfloat vert_step);
        ObjectType objectType(){return ANT;};
};

#endif // !defined(AFX_ANT_H__9D6D8C57_8DEF_45C8_B40F_269095AA595C__INCLUDED_)
