// Assignment2Doc.cpp : implementation of the CAssignment2Doc class
//

#include "stdafx.h"
#include "Assignment2.h"
#include "MainFrm.h"
#include "Assignment2Doc.h"
#include ".\assignment2doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAssignment2Doc




IMPLEMENT_DYNCREATE(CAssignment2Doc, CDocument)

BEGIN_MESSAGE_MAP(CAssignment2Doc, CDocument)
	//{{AFX_MSG_MAP(CAssignment2Doc)
	ON_COMMAND(ID_GENETIC, OnGenetic)
	ON_COMMAND(ID_INFO, OnInfo)
	ON_NOTIFY(NM_RELEASEDCAPTURE,  IDS_DECAYSLIDER, OnNMReleasedcaptureSlider1)
	ON_COMMAND(PHER_TOGGLE, TogglePheromone)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_VIEW_SETTINGS, OnViewSettings)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAssignment2Doc construction/destruction

CAssignment2Doc::CAssignment2Doc(CDNAStatement* antDNA):
Cols(50), Rows(50), 
AntNumber(DEFAULTANTNUM),
GridWidth(DEFAULTGRIDWIDTH), GridHeight(DEFAULTGRIDHEIGHT),
Env((Environment*)0),InfoWindow(NULL), m_PheromeneDecayRate(0.95){

	
	
	makeEnvironment();
	if(antDNA) 
		AntDNA = new CDNAStatement(*antDNA);
	else{
		AntDNA = new CDNAStatement();
	}
	((CMainFrame*)(AfxGetApp()->m_pMainWnd))->m_PheromoneDecaySlide.SetPos((int) (m_PheromeneDecayRate*100));

}



void CAssignment2Doc::destroy(){
	if(Env) delete Env;
//	((CMainFrame*)(AfxGetApp()->m_pMainWnd))->TimeClicks.
//	FoodParts.Create(ES_READONLY , CRect(100,0,150,20),this, ID_FOODLEFT);
}



void CAssignment2Doc::makeEnvironment(){

	destroy();
	Env = new Environment(Rows, Cols, AntNumber, m_PheromeneDecayRate);
	stringstream t;
	t << Env->getTotalFood();
	CString Str = _T(t.str().c_str());
	((CMainFrame*)(AfxGetApp()->m_pMainWnd))->FoodParts.SetWindowText((t.str()).c_str());
	
	TimeClicks = 0;
	((CMainFrame*)(AfxGetApp()->m_pMainWnd))->TimeClicks.SetWindowText("0");
	UpdateAllViews(NULL );
}

void CAssignment2Doc::draw(){
	if(Env) Env->draw(GridWidth, GridHeight);
}


void CAssignment2Doc::timeTick(){
	
	if(Env){ 
		Env->timeTick(*AntDNA);

		stringstream t;
		t << Env->getTotalFood();
		((CMainFrame*)(AfxGetApp()->m_pMainWnd))->FoodParts.SetWindowText((t.str()).c_str());
		stringstream t2;
		
		TimeClicks+=1;
		CString R;
		R.Format("%d", TimeClicks);
		((CMainFrame*)(AfxGetApp()->m_pMainWnd))->TimeClicks.SetWindowText(R.GetBuffer());
	}
}

CAssignment2Doc::~CAssignment2Doc(){
	if(AntDNA) delete AntDNA;
	destroy();
	//showMemLeaking(_T("CDNAStatements: "), CDNAStatement::MemTrace(0));
}

BOOL CAssignment2Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CAssignment2Doc serialization

void CAssignment2Doc::Serialize(CArchive& ar)
{

	AntDNA->Serialize(ar);
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
	
	int t = AntDNA->getDepth(); 
	
}

/////////////////////////////////////////////////////////////////////////////
// CAssignment2Doc diagnostics

#ifdef _DEBUG
void CAssignment2Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAssignment2Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAssignment2Doc commands

void CAssignment2Doc::OnInfo(){
	makeEnvironment();
	
}
void CAssignment2Doc::OnGenetic() 
{
	CAntGenetic p(AntDNA);
	p.DoModal();	
	AntDNA = p.getDNA(); 
}

void CAssignment2Doc::TogglePheromone(){
	Env->viewPheromone = !Env->viewPheromone;
}
void CAssignment2Doc::OnNMReleasedcaptureSlider1(NMHDR *pNMHDR, LRESULT *pResult)
{
	int a = ((CMainFrame*)(AfxGetApp()->m_pMainWnd))->m_PheromoneDecaySlide.GetPos();
	 m_PheromeneDecayRate = 0.01*(double)a;
	makeEnvironment();
	*pResult = 0;
}

void CAssignment2Doc::OnViewSettings()
{
	CInfoSetting T(NULL, Rows, Cols, AntNumber);
	T.DoModal();
	Rows = T.Rows;
	Cols = T.Cols;
	AntNumber = T.AntNum;
	makeEnvironment();
}










