// Assignment2View.cpp : implementation of the CAssignment2View class
//

#include "stdafx.h"
#include "Assignment2.h"

#include "Assignment2Doc.h"
#include "Assignment2View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAssignment2View

IMPLEMENT_DYNCREATE(CAssignment2View, CView)

BEGIN_MESSAGE_MAP(CAssignment2View, CView)
	//{{AFX_MSG_MAP(CAssignment2View)
	ON_WM_SIZE()
	ON_WM_ERASEBKGND()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_COMMAND(ID_GO, OnGo)
	ON_COMMAND(ID_STOP, OnStop)
	ON_COMMAND(ID_GRID, OnGrid)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAssignment2View construction/destruction

CAssignment2View::CAssignment2View():
GridDraw(false),
Cols(50),Rows(50),
running(false){

    
}


CAssignment2View::~CAssignment2View()
{
}

BOOL CAssignment2View::SetupPixelFormat( void ){

  static PIXELFORMATDESCRIPTOR pfd = 
    {
        sizeof(PIXELFORMATDESCRIPTOR),  // size of this pfd
        1,                              // version number
        PFD_DRAW_TO_WINDOW |            // support window
        PFD_SUPPORT_OPENGL |            // support OpenGL
        PFD_DOUBLEBUFFER,               // double buffered
        PFD_TYPE_RGBA,                  // RGBA type
        24,                             // 24-bit color depth
        0, 0, 0, 0, 0, 0,               // color bits ignored
        0,                              // no alpha buffer
        0,                              // shift bit ignored
        0,                              // no accumulation buffer
        0, 0, 0, 0,                     // accum bits ignored
//        32,                             // 32-bit z-buffer
        16, // NOTE: better performance with 16-bit z-buffer
        0,                              // no stencil buffer
        0,                              // no auxiliary buffer
        PFD_MAIN_PLANE,                 // main layer
        0,                              // reserved
        0, 0, 0                         // layer masks ignored
    };
    int pixelformat;

    if ( 0 == (pixelformat = ::ChoosePixelFormat(m_pDC->GetSafeHdc(), &pfd)) )
        {
            return FALSE;
        }

    if ( FALSE == ::SetPixelFormat(m_pDC->GetSafeHdc(), pixelformat, &pfd) )
        {
            return FALSE;
        }
    return TRUE;


}

BOOL CAssignment2View::InitializeOpenGL(){

    this->m_pDC = new CClientDC(this) ;
    if ( NULL == m_pDC ) 
    {
        TRACE("failure to get DC") ;
        return false;
    }
    if (!SetupPixelFormat())
    {
        return false;
    }

    if ( 0 == (m_hrc = ::wglCreateContext( m_pDC->GetSafeHdc() ) ) )
        {
        return false;
        }

    if ( FALSE == ::wglMakeCurrent( m_pDC->GetSafeHdc(), m_hrc ) )
        {
        
            return false;
        }   


    ::glClearColor(0.0f, 0.0f, 0.0f, 0.0f) ;
    ::glClearDepth( 1.0f );
    ::glEnable( GL_DEPTH_TEST );
    ::glEnable(GL_LIGHTING) ;
    ::glEnable(GL_LIGHT0) ;
    ::glColorMaterial(GL_FRONT, GL_AMBIENT_AND_DIFFUSE) ;
    ::glEnable(GL_COLOR_MATERIAL) ;

    return true;
}


BOOL CAssignment2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= WS_CLIPSIBLINGS | WS_CLIPCHILDREN;
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAssignment2View drawing

void CAssignment2View::OnDraw(CDC* pDC)
{
	BOOL bResult = wglMakeCurrent (pDC->m_hDC, m_hrc);
    if (!bResult)
    {
          TRACE("wglMakeCurrent Failed %x\r\n", GetLastError() ) ;
    }

    
    ::glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
    
    ::glPushMatrix();
    ::glTranslatef(0.0f, 0.0f, 0.0f);                         
        RenderScene() ;
    ::glPopMatrix();

    ::glFinish();


    if ( FALSE == ::SwapBuffers( m_pDC->GetSafeHdc() ) )
        {

        } 
}


void CAssignment2View::RenderScene(){
	if(GridDraw) drawGrid();
	DocPtr->draw();
	if(running){
		DocPtr->timeTick();
		InvalidateRect( 0, FALSE );
		GetParent()->PostMessage(WM_PAINT);
	}
}



void CAssignment2View::drawGrid(){

    GLfloat GridTop  = (DocPtr->GridHeight)/2.0;//(GLfloat)2.0f;
    GLfloat GridLeft = -(DocPtr->GridWidth)/2.0;//(GLfloat)-2.0f;


    GLfloat hor_step  = DocPtr->GridWidth/Cols;
    GLfloat vert_step = DocPtr->GridHeight/Rows;

    

    for(int i=0; i<=Rows;i++){
        glPushMatrix();
        glTranslatef(0.0f, GridTop-(i*vert_step), 0.0f);
		 glColor3f(0.6f, 0.7f, 0.85f);
        glBegin(GL_LINES);
            glVertex3f(GridLeft, 0.0f, 0.0f);
            glVertex3f(-GridLeft, 0.0f, 0.0f);
        glEnd();
        glPopMatrix();
    }

    for(int j=0; j<=Cols;j++){
        glPushMatrix();
        glTranslatef(GridLeft+(j*hor_step), 0.0f, 0.0f);

        glBegin(GL_LINES);
            glColor3f(0.6f, 0.7f, 0.85f);
            glVertex3f(0.0f,GridTop, 0.0);
            glVertex3f(0.0f, -GridTop, 0.0f);
        glEnd();
        glPopMatrix();
    }
}
/////////////////////////////////////////////////////////////////////////////
// CAssignment2View printing

BOOL CAssignment2View::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CAssignment2View::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CAssignment2View::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CAssignment2View diagnostics

#ifdef _DEBUG
void CAssignment2View::AssertValid() const
{
	CView::AssertValid();
}

void CAssignment2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CAssignment2Doc* CAssignment2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAssignment2Doc)));
	return (CAssignment2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAssignment2View message handlers

void CAssignment2View::OnSize(UINT nType, int cx, int cy) 
{
   CView::OnSize(nType, cx, cy);
    WinWidth = (GLfloat) cx;
    WinHeight = (GLfloat) cy;

    CClientDC dc(this);
    BOOL bResult = wglMakeCurrent (dc.m_hDC, m_hrc);
    if (!bResult){
      TRACE("wglMakeCurrent Failed %x\r\n", GetLastError() ) ;
      return ;
    }

    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
        
    glOrtho(0.0f,(GLdouble) cx, (GLdouble) -cy, 0.0f, 0.0, 0.0 /*0.1f, 100.0f*/);
    glViewport(0, 0, cx, cy);
    glMatrixMode(GL_MODELVIEW);                         // Select The Modelview Matrix
    glLoadIdentity();                                   // Reset The Modelview Matrix                             // Reset The Modelview Matrix
}

BOOL CAssignment2View::OnEraseBkgnd(CDC* pDC) 
{
	return true;
}

int CAssignment2View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	InitializeOpenGL();
    DocPtr = GetDocument();
    return 0;
}

void CAssignment2View::OnDestroy() 
{
	CView::OnDestroy();
	
	wglMakeCurrent(NULL, NULL) ;
    if (m_hrc){
        wglDeleteContext(m_hrc) ;
        m_hrc = NULL ;
    }
}

void CAssignment2View::OnGo() 
{
	running = true;
	InvalidateRect( 0, FALSE );
	GetParent()->PostMessage(WM_PAINT);
}

void CAssignment2View::OnStop() 
{
	running = false;
	InvalidateRect( 0, FALSE );
	GetParent()->PostMessage(WM_PAINT);
}


void CAssignment2View::OnGrid() 
{
	GridDraw = !GridDraw;
	InvalidateRect( 0, FALSE );
	GetParent()->PostMessage(WM_PAINT);
}
