#pragma once


// EvolveDoc document

class EvolveDoc : public CDocument
{
	DECLARE_DYNCREATE(EvolveDoc)


	void userMessage1();
protected:
	
	bool running;
	void deletePop();
	void createNewPop();
	double grade(CDNAStatement*);
	void makeEnvironment();
	void destroy();


	int EnvTime;
	int Rows;
	int Cols;
	int AntNumber;
	int m_PheromeneDecayRate;
	int SelectionSize;
	int generation;
	int CrossMaxDepth;
	int MaxDepth;
	double MutProb;

	

	double getTotalFitness(){
		double Total = 0.0;
		for(int i=0; i<Population.size();i++)
			if(Population[i])
				Total += Population[i]->fitness;
		return Total;
	}
public:

	Environment* Env;
	vector<CDNAStatement*> Population;
	int CurrentPopMember;
	int PopCount;

	void show();

	EvolveDoc(int popCount = 200);
	virtual ~EvolveDoc();
	virtual void Serialize(CArchive& ar);   // overridden for document i/o
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	virtual BOOL OnNewDocument();

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	afx_msg void OnViewSettings();
	afx_msg void OnStop();
	afx_msg void EvaluateAll();
	afx_msg void Select();
	afx_msg void Breed();
	afx_msg void EvolveBastard();
	afx_msg void PlayTheCDNA();
};
