// EvolveView.cpp : implementation file
//

#include "stdafx.h"
#include "Assignment2.h"
#include "EvolveView.h"
#include "EvolveDoc.h"
#include ".\evolveview.h"


// CEvolveView

IMPLEMENT_DYNCREATE(CEvolveView, CListView)

CEvolveView::CEvolveView()
{
}

CEvolveView::~CEvolveView()
{
}

BEGIN_MESSAGE_MAP(CEvolveView, CListView)
	ON_WM_CREATE()
	ON_NOTIFY_REFLECT(NM_DBLCLK, OnNMDblclk)
	ON_NOTIFY_REFLECT(NM_CLICK, OnNMClick)
END_MESSAGE_MAP()


// CEvolveView diagnostics

#ifdef _DEBUG
void CEvolveView::AssertValid() const
{
	CListView::AssertValid();
}

void CEvolveView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG


// CEvolveView message handlers

int CEvolveView::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CListView::OnCreate(lpCreateStruct) == -1)
		return -1;

	//ListCtrl = &GetListCtrl( );
	ASSERT(GetStyle() & LVS_REPORT);

	// Gain a reference to the list control itself
	ListCtrl = &GetListCtrl();
	ListCtrl->InsertColumn(0, _T("Individual ID"), LVCFMT_LEFT,75,0);
	ListCtrl->InsertColumn(1, _T("Fitness"), LVCFMT_LEFT,75,2);
	ListCtrl->InsertColumn(2, _T("Individual"), LVCFMT_LEFT,3000,1);


	return 0;
}


void CEvolveView::UpdateList(){
	
	CString strText;
	//int nColumnCount = ListCtrl->GetHeaderCtrl()->GetItemCount();
	ListCtrl->DeleteAllItems();

	EvolveDoc*  DocPtr = (EvolveDoc*) this->GetDocument();
	for(int i=0; i<DocPtr->Population.size(); i++){ 

		ListCtrl->InsertItem(
		LVIF_TEXT|LVIF_STATE, i, strText, 
		/*(i%2)==0 ? LVIS_SELECTED : */0, LVIS_SELECTED,
		0, 0);
		
		strText.Format(TEXT("%d"), i);
		ListCtrl->SetItemText(i, 0,strText);
		if(DocPtr->Population[i]){
			strText.Format(TEXT("%f"), DocPtr->Population[i]->fitness);
			ListCtrl->SetItemText(i, 1, strText);
			ListCtrl->SetItemText(i, 2, DocPtr->Population[i]->toString());
		}
		else{
			ListCtrl->SetItemText(i, 1, _T("----"));
			ListCtrl->SetItemText(i, 2, _T("----"));
		}
	}

	if(DocPtr->CurrentPopMember > -1)
		ListCtrl->SetSelectionMark(DocPtr->CurrentPopMember);
	/*ListCtrl->SortItems(PFNLVCOMPARE pfnCompare,
		DWORD_PTR dwData );*/
}
BOOL CEvolveView::PreCreateWindow(CREATESTRUCT& cs)
{
	cs.style = (cs.style & ~LVS_TYPEMASK) | LVS_REPORT;
	cs.style |= LVS_AUTOARRANGE;
	return CListView::PreCreateWindow(cs);
}

void CEvolveView::OnDraw(CDC* pDC)
{
	CView::OnDraw(pDC);
}

void CEvolveView::OnUpdate(CView* /*pSender*/, LPARAM /*lHint*/, CObject* /*pHint*/)
{
	UpdateList();
}

void CEvolveView::OnNMDblclk(NMHDR *pNMHDR, LRESULT *pResult)
{


	CListCtrl& list = GetListCtrl();
	int nSelected = list.GetSelectedCount();
	// only proceed if one item selected....
	if ( nSelected == 1 )
	{
		EvolveDoc*  DocPtr = (EvolveDoc*) this->GetDocument();
		DocPtr->CurrentPopMember = list.GetSelectionMark();
		DocPtr->show();

	}
	*pResult = 0;
}

void CEvolveView::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	CListCtrl& list = GetListCtrl();
	int nSelected = list.GetSelectedCount();
	// only proceed if one item selected....
	if ( nSelected == 1 )
	{	
		EvolveDoc*  DocPtr = (EvolveDoc*) this->GetDocument();
		DocPtr->CurrentPopMember = list.GetSelectionMark();
	}
	
	*pResult = 0;
}
