// Pheromone.cpp: implementation of the Pheromone class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Assignment2.h"
#include "Pheromone.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

Pheromone::Pheromone(int X, int Y, 
                     unsigned char type, double fer):
EnvObject(X, Y), Type(type),
Strength(0.0f), MaxStrength(0.0f), m_PheromeneDecayRate(fer){

	if(isAntHillPheromone())     
		{MaxStrength = HILLPHEROMONESTRENGTH;}
	else
    if(isExplorePheromone())     
		{MaxStrength = XPLOPHEROMONESTRENGTH;}
	else
	if(isFoodCarryingPheromone())
		{MaxStrength = FOODPHEROMONESTRENGTH;}

        refreshPheromone();
}


Pheromone::Pheromone(const Pheromone& P):
EnvObject(P.x, P.y),  Type(P.Type),
Strength(P.Strength), MaxStrength(P.MaxStrength), m_PheromeneDecayRate(P.m_PheromeneDecayRate){


}


void Pheromone::draw(GLfloat hor_step, GLfloat vert_step){

		glColor3f(1.0f, 0.7f, 0.85f);
		glBegin(GL_QUADS);          
            glVertex3f(0.0, 0.0, 0.0);
            glVertex3f(0.0, vert_step, 0.0);
            glVertex3f((hor_step*Strength)/(MaxStrength), vert_step/2.0f, 0.0);
            glVertex3f(hor_step/2.0f, 0.0, 0.0);
        glEnd();
}

Pheromone::~Pheromone()
{

}
